
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title CMP (immediate)

@encoding(t1) {

    @half 0 0 1 0 1 Rn(3) imm8(8)

    @syntax <Rn> <const>

    @conv {

        Rn = Register(Rn)
        const = ZeroExtend(imm8, 8, 32)

    }

}

@encoding(T2) {

    @word 1 1 1 1 0 i(1) 0 1 1 0 1 1 Rn(4) 0 imm3(3) 1 1 1 1 imm8(8)

    @syntax <Rn> <const>

    @conv {

        Rn = Register(Rn)
        const = ThumbExpandImm(i:imm3:imm8)

    }

    @rules {

        if (Rn == '1111') ; unpredictable

    }

}

@encoding(A1) {

    @word cond(4) 0 0 1 1 0 1 0 1 Rn(4) 0 0 0 0 imm12(12)

    @syntax {c} <Rn> <const>

    @conv {

        c = Condition(cond)
        Rn = Register(Rn)
        const = ARMExpandImm(imm12)

    }

}
