
/* Chrysalide - Outil d'analyse de fichiers binaires
 * params.h - prototypes pour la modulation des paramètres de rendu
 *
 * Copyright (C) 2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _GTKEXT_GRAPH_PARAMS_H
#define _GTKEXT_GRAPH_PARAMS_H




/* Coordonnés d'un noeud non initialisées */
#define UNINITIALIZED_NODE_POS G_MININT


/**
 * Paramètres à l'échelle du graphique.
 */

/* Bordures supérieure et inférieure des graphiques */
#define GRAPH_VERTICAL_MARGIN 15

/* Bordures gauche et droite des graphiques */
#define GRAPH_HORIZONTAL_MARGIN 15


/**
 * Paramètres à l'échelle du noeud.
 */





#define NODE_LEFT_MARGIN 25
#define NODE_TOP_MARGIN 55      /* TODO : supprimer */






/* Séparations minimales entre deux liens */
#define EDGE_HORIZONTAL_MIN_SEP 10
#define EDGE_VERTICAL_MIN_SEP 10

/* Séparations minimales entre un lien et un noeud */
#define EDGE_SLOT_HORIZ_MARGIN 20
#define EDGE_SLOT_VERT_MARGIN 20

/* Séparations minimales entre un noeud et un autre */
#define NODE_HORIZONTAL_MARGIN 20
#define NODE_VERTICAL_MARGIN 35




#define SLOT_VERT_SEP EDGE_SLOT_VERT_MARGIN   /* TODO : remplacer */

#define ARROW_LENGHT 10
#define ARROW_DEGREES 10




#endif  /* _GTKEXT_GRAPH_PARAMS_H */
